<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-gb" lang="en-gb" dir="ltr">
	<head>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<title>pxDoc - Papyrus Integration</title>
		<link rel="stylesheet" href="resources/documentation.css" type="text/css"/>
		<link href="share/syntaxhighlighter/shCore.css" rel="stylesheet" type="text/css" />
		<link href="share/syntaxhighlighter/pxdoc.css" rel="stylesheet" type="text/css" />
		<script src="share/syntaxhighlighter/shCore.js" type="text/javascript"></script>
		<script src="share/syntaxhighlighter/syntaxhighlighter.js" type="text/javascript"></script>
		<style type='text/css'>
				body {counter-reset: h2}
				  h2 {counter-reset: h3}
				  h3 {counter-reset: h4}
				  h4 {counter-reset: h5}
				  h5 {counter-reset: h6}
				  h6 {counter-reset: h7}
				
				  h2:before {counter-increment: h2; content: counter(h2) ". "}
				  h3:before {counter-increment: h3; content: counter(h2) "." counter(h3) ". "}
				  h4:before {counter-increment: h4; content: counter(h2) "." counter(h3) "." counter(h4) ". "}
				  h5:before {counter-increment: h5; content: counter(h2) "." counter(h3) "." counter(h4) "." counter(h5) ". "}
				  h6:before {counter-increment: h6; content: counter(h2) "." counter(h3) "." counter(h4) "." counter(h5) "." counter(h6) ". "}
				
				  h2.nocount:before, h3.nocount:before, h4.nocount:before, h5.nocount:before, h6.nocount:before { content: ""; counter-increment: none } 
				</style>
		
	</head>
	<body>
	<h1>pxDoc - Papyrus Integration</h1>
	<ul>
	<li><a href="pxDocPapyrusIntegration.html#Installation">Installation</a></li>
	<li><a href="pxDocPapyrusIntegration.html#Quickstart">Quick start</a><ul>
	<li><a href="pxDocPapyrusIntegration.html#Browsetheexamples">Browse the examples</a></li>
	<li><a href="pxDocPapyrusIntegration.html#InitializeanewpxDocgenerator">Initialize a new pxDoc generator</a></li>
	<li><a href="pxDocPapyrusIntegration.html#launcherWizard">Launching the generation</a></li>
						</ul></li>
	<li><a href="pxDocPapyrusIntegration.html#useCommonLibs">Use the pxDoc common libs in your generator</a><ul>
	<li><a href="pxDocPapyrusIntegration.html#queryDiagrams">Query and include Papyrus Diagrams</a></li>
						</ul></li>
	<li><a href="pxDocPapyrusIntegration.html#GitLab">Find the project on GitLab</a></li>
	<li><a href="pxDocPapyrusIntegration.html#pxDoc">Get support on pxDoc</a></li>
				</ul>
	This enabler provides full pxDoc capabilities to the <a href="https://www.eclipse.org/papyrus/" target="_blank">Papyrus UML2 modeling environment</a> .
	<h2 id="Installation">Installation</h2>
				<p><b>First make sure that pxDoc is already installed</b> (if this is not the case: <a href="https://pxdoc.fr/index.php/download" target="_blank">install pxDoc</a>).</p>
										<p> To install the enabler:</p>
							<ul>
							<li>In Eclipse, Choose <b><i>Help -> Install New Software...</i></b> from the menu bar and <b><i>Add....</i></b></li>
							<li>Insert the <a href="http://www.pxdoc.fr/updates/pxdoc-papyrus/releases">http://www.pxdoc.fr/updates/pxdoc-papyrus/releases</a> URL.</li>
							<li>Select the <i>pxDoc Papyrus Integration</i> from the category <i>pxDoc Integrations</i> and complete the wizard by clicking the <b><i>Next</i></b> button until you can click <b><i>Finish.</i></b></li>
							<li>After a quick download and a restart of Eclipse, the pxDoc Papyrus enabler is ready to use.</li>
							</ul>
							<p>You can also test the nightly built: <a href="http://www.pxdoc.fr/updates/pxdoc-papyrus/nightly">update site nightly built</a>
	<h2 id="Quickstart">Quick start</h2>
			<h3 id="Browsetheexamples">Browse the examples</h3>
					<p>Once installed, you can import the <b>UML Generic</b> example dedicated to Papyrus, and many other pxDoc sample projects.:</p>	
								<p>Then <b><i>File -> New -> Example...</i></b></p>
					<img src="images/papyrus-enabler/new-example.png"/>
					<p><b>Note:</b> The sample generator is included as plugin in the enabler, so you can launch the generation directly from a model, without installing the examples.</p>
			<h3 id="InitializeanewpxDocgenerator">Initialize a new pxDoc generator</h3>
					<p>See <a href='https://pxdoc.fr/index.php/manageproject#wizardCreation'>Project creation</a> for more details on pxDoc projects creation.</p>
								<p>First create an empty pxDoc project, with <b><i>File -> New -> Project...</i></b> and select the <i>pxDoc Project</i> wizard.</p>
								<p>In the second page of the wizard (see screenshot below), select the <i>Papyrus</i> enabler. If you do not want the common libraries (common modules and associated means) to be automatically imported in your project, un-check the checkbox.<p>
								 <p>If you do not have a Word stylesheet (.dotx file) available, you can select the one deployed in the EMF Generic Generator</p>
					<img src="images/papyrus-enabler/new-project.png" width="700"/>
					<p>Click on finish.</p>
									<p> First, the pxDoc project itself is created and the <i>.pxdoc</i> file opens. You may notice errors in this project during few seconds:</p>
					<img src="images/papyrus-enabler/new-project-2.png" width="700"/>
					<p>These errors are automatically solved with the second step of the project creation:</p>
					<img src="images/papyrus-enabler/new-project-3.png" width="700"/>
					<p>If you included the Common Libraries, your last step is to properly bind the <a href="https://pxdoc.fr/index.php/documentconcepts#applyStyles" target="_blank">variable styles</a> from the modules with the chosen stylesheet: use CTRL-SPACE to get all available styles (from the stylesheet) suggested.</p>
					<img src="images/papyrus-enabler/new-project-style-binding.PNG" width="700"/>
					<div class="note">
					<p>Your pxDoc generator is ready to use with a Papyrus model.</p>
									<p><b> Do not hesitate to go through the provided examples and the <a href="http://www.pragmatic-modeling.org/index.php?option=com_content&view=article&id=17&Itemid=132" target="_blank"><i>Common Libraries</i> documentation</a> to learn quickly how to rule with pxDoc!</b></p>
					</div>
			<h3 id="launcherWizard">Launching the generation</h3>
					<p>To test or launch your generator,:</p>
								<ol><li> select <i>Debug As</i> or <i>Run As -> Eclipse Application</i>.</li>
					<div class="note">
						<p>In Debug mode, the modifications made to your generator are automatically taken into account, so you just need to re-launch the generation in the 2nd Eclipse to see the result.</p>
					</div>
					<li>Import your source model, data... in this 2nd Eclipse</li>
								<li>To enable the pxDoc menu, right click on a relevant object of this source (according to the command object defined in the <span class="pxDocKeyword">root template</span> of your Generator).</li>
								</ol>
								<p>The launching wizard will pop up</p>.
					<div class="note">
					Refer to <a href="https://pxdoc.fr/index.php/5-min-tutorial" target = "_blank">5min tutorial</a> and to the <a href="https://pxdoc.fr/index.php/15-min-tutorial-generate-a-document-from-a-simple-model" target="_blank">15 min tutorial</a> to get a better view on generation launching!
					</div>
	<h2 id="useCommonLibs">Use the pxDoc common libs in your generator</h2>
			If you did not uncheck the <i>Use pxDoc libs</i> in the project creation wizard, you can take benefits of the <a href="http://www.pragmatic-modeling.org/index.php?option=com_content&view=article&id=17&Itemid=132" arget="_blank">pxDoc Common Libraries</a>.<p>
					<p>With these libraries, your generator is ready to:</p>
					<ul><li>Use the Papyrus Description Provider to benefits from  CommonServices and EmfServices to include the description of an element (incl. its icon, attributes...) in several formats (table, bullet point)</li>
					<li>Query and include Papyrus diagrams</li>
					<li><b>Use the templates of the <i>UMLCommon</i> Module dedicated to each type of element (class, interface, component...)</b>. You can import the library in your workspace from the Plug-ins view: /org.pragmaticmodeling.pxdoc.uml.common.lib </li></ul>
					<p></p>
					<p><i>If you unchecked the <i>Use pxDoc libs</i> checkbox, you can of course import manually the Modules and plugins. Do not forget to add the relevant dependencies to the MANIFEST.MF of the project.</i></p> 
			<h3 id="queryDiagrams">Query and include Papyrus Diagrams</h3>
					<p>Below are some sample queries you can use:</p>
					<pre class="brush: pxdoc" style="white-space:pre-wrap;">
					 
									// diagrams owned by the 'model' object
								var List&lt;Diagram&gt; ownedDiagrams = queryDiagrams(model).execute;
					
								// all diagrams owned directly and indirectly by the 'model' object
								var List&lt;Diagram&gt; allOwnedDiagrams = queryDiagrams(model).searchNested.execute;
					
								// diagrams owned by the 'model' object, with some content
								var List&lt;Diagram&gt; ownedNonEmptyDiagrams = queryDiagrams(model).notEmpty.execute;
					
								// look for a diagram owned by 'model' and named 'A diagram name'
								var List&lt;Diagram&gt; diagramsByName = queryDiagrams(model).name('A diagram name').execute;
					
								// look for a diagram owned by 'model' with name staring with 'ABC'
								var List&lt;Diagram&gt; diagramsByNameStartingWith = queryDiagrams(model).nameStartsWith('ABC').execute;
					
								// diagrams by type
								var List&lt;Diagram&gt; diagramsByType_CDB = queryDiagrams(model).type('CDB').execute;
					
								// diagrams with type 'CDB' and name starting with 'MyString'
								var List&lt;Diagram&gt; cdbStartingWithMyString = queryDiagrams(model).type('CDB').nameStartsWith('MyString').
									execute;</pre>
					<<p>To include the diagrams:</>
					<pre class="brush: pxdoc" style="white-space:pre-wrap;">
					
								// Your defined query
								var List&lt;Diagram&gt; myDiagramQueryName = queryDiagrams(model).execute;
					
								// Use the template from the DiagramsService module
								// (as you can see, you can apply a template directly on a List of objects: no need to define explicitly a loop!)
								apply includeDiagram(myDiagramQueryName)
					
								// OR insert the diagram image by yourself...
								for (diagram : myDiagrams) {
									
									// use the pxdoc 'image' keyword with diagram image file path stored in the 'path' diagram attribute.
									image path:diagram.path  
									// add a title with a style
									#Figure keepWithNext align:center {
										diagram.name
									}
									// include diagram documentation if any
									if (!diagram.documentation.empty) {
										#BodyText {diagram.documentation}
									}
								}</pre>
	<h2 id="GitLab">Find the project on GitLab</h2>
			You can find the source project on GitLab: <a href="https://gitlab.com/pxdoc/pxdoc-papyrus" target = "_blank">https://gitlab.com/pxdoc/pxdoc-papyrus</a>.
	<h2 id="pxDoc">Get support on pxDoc</h2>
			<p>Read the documentation on <a href="https://www.pxdoc.fr/index.php/documentation" target="_blank">www.pxdoc.fr</a>.</p>
	</body>
</html>